//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script = {
  name: 'VueModal',
  props: {
    title: {
      type: String,
      default: 'Modal'
    },
    width: {
      type: String,
      default: '80%'
    }
  },

  data() {
    return {};
  },

  methods: {
    closeModal() {
      let element = document.querySelector(".modal-parent");
      element.classList.remove('modal-open');
      element.classList.add('modal-close');
    },

    openModal() {
      let element = document.querySelector(".modal-parent");
      element.addEventListener("click", e => {
        if (e.target.classList[0] == 'modal-parent') {
          e.target.classList.add('modal-close');
        }

        e.stopPropagation();
      }, false);
      element.classList.remove('modal-close');
      element.classList.add('modal-open');
      let elements = document.querySelector('.modal-form-01').getElementsByClassName('keyboard-accessible');

      if (elements.length > 0) {
        elements[0].focus();
        elements[0].addEventListener("keydown", e => {
          if (e.shiftKey && e.key == 'Tab') {
            e.preventDefault();
          }
        });
        elements[elements.length - 1].addEventListener("keydown", e => {
          if (e.key == 'Tab') {
            e.preventDefault();
            document.querySelector('.modal-close-01').focus();
            document.querySelector('.modal-close-01').addEventListener("keydown", e2 => {
              if (e2.shiftKey && e2.key == 'Tab') {
                e2.preventDefault();
              }
            });
          }
        });
      } else {
        document.querySelector('.modal-close-01').addEventListener("keydown", e2 => {
          if (e2.shiftKey && e2.key == 'Tab') {
            e2.preventDefault();
          } else if (e2.key == 'Tab') {
            e2.preventDefault();
          }
        });
      }
    }

  }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}

const isOldIE = typeof navigator !== 'undefined' &&
    /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
function createInjector(context) {
    return (id, style) => addStyle(id, style);
}
let HEAD;
const styles = {};
function addStyle(id, css) {
    const group = isOldIE ? css.media || 'default' : id;
    const style = styles[group] || (styles[group] = { ids: new Set(), styles: [] });
    if (!style.ids.has(id)) {
        style.ids.add(id);
        let code = css.source;
        if (css.map) {
            // https://developer.chrome.com/devtools/docs/javascript-debugging
            // this makes source maps inside style tags work properly in Chrome
            code += '\n/*# sourceURL=' + css.map.sources[0] + ' */';
            // http://stackoverflow.com/a/26603875
            code +=
                '\n/*# sourceMappingURL=data:application/json;base64,' +
                    btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) +
                    ' */';
        }
        if (!style.element) {
            style.element = document.createElement('style');
            style.element.type = 'text/css';
            if (css.media)
                style.element.setAttribute('media', css.media);
            if (HEAD === undefined) {
                HEAD = document.head || document.getElementsByTagName('head')[0];
            }
            HEAD.appendChild(style.element);
        }
        if ('styleSheet' in style.element) {
            style.styles.push(code);
            style.element.styleSheet.cssText = style.styles
                .filter(Boolean)
                .join('\n');
        }
        else {
            const index = style.ids.size - 1;
            const textNode = document.createTextNode(code);
            const nodes = style.element.childNodes;
            if (nodes[index])
                style.element.removeChild(nodes[index]);
            if (nodes.length)
                style.element.insertBefore(textNode, nodes[index]);
            else
                style.element.appendChild(textNode);
        }
    }
}

/* script */
const __vue_script__ = script;
/* template */

var __vue_render__ = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "modal-parent modal-close"
  }, [_c('div', {
    staticClass: "modal-body",
    style: {
      width: _vm.width
    }
  }, [_c('div', {
    staticClass: "modal-top"
  }, [_c('span', {
    staticClass: "heading"
  }, [_vm._v(_vm._s(_vm.title))]), _vm._v(" "), _c('button', {
    staticClass: "modal-close-01",
    attrs: {
      "aria-label": "close"
    },
    on: {
      "click": function ($event) {
        return _vm.closeModal();
      }
    }
  }, [_vm._v("×")])]), _vm._v(" "), _c('div', {
    staticClass: "modal-form-01"
  }, [_vm._t("default")], 2)])]);
};

var __vue_staticRenderFns__ = [];
/* style */

const __vue_inject_styles__ = function (inject) {
  if (!inject) return;
  inject("data-v-6cfe38be_0", {
    source: ".modal-parent[data-v-6cfe38be]{position:fixed;z-index:1;padding-top:100px;left:0;top:0;width:100%;height:100%;overflow:auto;background-color:#000;background-color:rgba(0,0,0,.4)}.modal-open[data-v-6cfe38be]{display:block}.modal-close[data-v-6cfe38be]{display:none}.modal-parent .modal-body[data-v-6cfe38be]{background-color:#fefefe;margin:auto;padding:20px;border:1px solid #888}.modal-parent .modal-body .modal-form-01[data-v-6cfe38be]{margin-top:50px}.modal-parent .modal-body .modal-top .modal-close-01[data-v-6cfe38be]{color:#d34fff;font-size:20px;font-weight:700;text-decoration:none;background:#fff;padding:2px 8px;border-radius:40px;border:3px solid #d34fff;float:right}.modal-parent .modal-body .modal-top .heading[data-v-6cfe38be]{color:#aaa;float:left;font-size:28px;font-weight:700}.modal-parent .modal-body .modal-top .modal-close-01[data-v-6cfe38be]:focus,.modal-parent .modal-body .modal-top .modal-close-01[data-v-6cfe38be]:hover{color:#9a0bc9;text-decoration:none;cursor:pointer;transition:.5s}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


const __vue_scope_id__ = "data-v-6cfe38be";
/* module identifier */

const __vue_module_identifier__ = undefined;
/* functional template */

const __vue_is_functional_template__ = false;
/* style inject SSR */

/* style inject shadow dom */

const __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, createInjector, undefined, undefined);

var component = __vue_component__;

// Import vue component
// IIFE injects install function into component, allowing component
// to be registered via Vue.use() as well as Vue.component(),

var entry_esm = /*#__PURE__*/(() => {
  // Get component instance
  const installable = component; // Attach install function executed by Vue.use()

  installable.install = Vue => {
    Vue.component('VueModal', installable);
  };

  return installable;
})(); // It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = directive;

export { entry_esm as default };
